-- require "math"

-- ThisAddon_Version = "1.0";

SLASH_FACTIONS1 = "/factions"
SLASH_DICE1 = "/dice"
SLASH_PRINTTIME1 = "/printtime"
SLASH_RE1 = "/re"



absoluteXmin = GetScreenWidth()/-2 + 78.5185546875		-- -680
absoluteXmax = GetScreenWidth()/2 - 78.5185546875		-- 680

absoluteYmin = GetScreenHeight()/-2 + 46.66668701172	-- -380
absoluteYmax = GetScreenHeight()/2 - 46.66668701172		-- 380




---------- INTERFACE PANEL OPTIONS ----------



----- FUNCTION AND FRAME FOR LOGON EVENT -- INTERFACE PANEL OPTIONS -----

local function onEvent(self, event, addOnName)
	if addOnName == "Dice" then
		DiceDB = DiceDB or {}
		DiceDB.sessions = (DiceDB.sessions or 0) + 1

		if (DiceDB.sessions == 1) then
			DiceDB.xDefault = 0
			DiceDB.yDefault = 0
			DiceDB.xSliderDefault = 50
			DiceDB.ySliderDefault = 50
			DiceDB.msgEnable = 0
			DiceDB.showDice = 0
			DiceDB.minimapPosition = 0
			DiceDB.isShowing = 0
		end

		correspondingX = DiceDB.xDefault
		correspondingY = DiceDB.yDefault

		if ( correspondingX < 0 ) then
			correspondingX_slider = ( 50*absoluteXmin - 50*correspondingX ) / absoluteXmin

		elseif ( correspondingX > 0 ) then
			correspondingX_slider = ( 50*absoluteXmax + 50*correspondingX ) / absoluteXmax

		elseif ( correspondingX == 0 ) then
			correspondingX_slider = 50

		end


		if ( correspondingY < 0 ) then
			correspondingY_slider = ( 50*absoluteYmin - 50*correspondingY ) / absoluteYmin

		elseif ( correspondingY > 0 ) then
			correspondingY_slider = ( 50*absoluteYmax + 50*correspondingY ) / absoluteYmax

		elseif ( correspondingY == 0 ) then
			correspondingY_slider = 50

		end

		xSlider_init = DiceDB.xSliderDefault
		ySlider_init = DiceDB.ySliderDefault

		msgEnable = DiceDB.msgEnable
		showDice = DiceDB.showDice

		print("---------------------------------------------")
		print("You've loaded the Dice addon " .. DiceDB.sessions .. " times.")
		print("Dice x position is saved as: " .. DiceDB.xDefault .. ".")
		print("Dice y position is saved as: " .. DiceDB.yDefault .. ".")
		if (msgEnable == 1) then
			print("Roll messages are enabled.")
		else
			print("Roll messages are disabled. (default setting)")
		end
		if (showDice == 1) then
			print("Dice is shown by default.")
		else
			print("Dice is hidden by default. (default setting)")
		end
		print("---------------------------------------------")

		if (DiceDB.showDice == 1) then
			isShowing = 1
			redrawDice(correspondingX, correspondingY)
			showDiceDefault()
		end

		if (DiceDB.showDice == 0) then
			isShowing = 0
		end

		loadSliderPosition(DiceDB.xSliderDefault, DiceDB.ySliderDefault)

		angle_init = DiceDB.minimapPosition
		xPos_init = 80*cos(angle)
		yPos_init = 80*sin(angle)

		xGoTo_miniMap = xPos_init
		yGoTo_miniMap = yPos_init

		angle = DiceDB.minimapPosition

		moveMinimapButton(DiceDB.minimapPosition)

	end
end

local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", onEvent)


-------------------------------------------------------------------------





--------- ADD INTERFACE OPTIONS PANES, POPULATE WITH FRAMES ----------


Dice = {};
Dice.panel = CreateFrame("Frame", "MyAddonPanel", UIParent);

-- Set the name for the Category for the Options Panel
Dice.panel.name = "Dice";

-- Add the panel to the Interface Options
InterfaceOptions_AddCategory(Dice.panel);


-- Make a child panel
Dice.childpanel = CreateFrame("Frame", "MyAddonChild", Dice.panel);
Dice.childpanel.name = "More options";

-- Specify childness of this panel (makes the little red [+], instead of making new panel)
Dice.childpanel.parent = Dice.panel.name;

-- Add the child to the Interface Options
InterfaceOptions_AddCategory(Dice.childpanel);


-- Create the scrolling parent frame and size it to fit inside the texture
local scrollFrame = CreateFrame("ScrollFrame", nil, Dice.panel, "UIPanelScrollFrameTemplate")
scrollFrame:SetPoint("TOPLEFT", 3, -4)
scrollFrame:SetPoint("BOTTOMRIGHT", -27, 4)

-- Create the scrolling child frame, set its width to fit, and give it an arbitrary minimum height (such as 1)
local scrollChild = CreateFrame("Frame")
scrollFrame:SetScrollChild(scrollChild)
scrollChild:SetWidth(InterfaceOptionsFramePanelContainer:GetWidth()-18)
scrollChild:SetHeight(1)

-- Add title text to the scroll child frame
local title = scrollChild:CreateFontString("ARTWORK", nil, "GameFontNormalLarge")
title:SetPoint("TOP", -5, -30)
title:SetText("-- DICE CONFIGURATION MENU --")

-- Add footer text to the scroll child frame
local footer = scrollChild:CreateFontString("ARTWORK", nil, "GameFontNormal")
footer:SetPoint("TOP", 0, -600)
footer:SetText("Copyright World Wide Web World Wide Industries 2022. All Rights Reserved.\n---\n ")


----------------------------------------------------------------------





----- INTERFACE OPTIONS CHECK BOX (Save settings) AND ON EVENT FUNCTION

local checkBtn = CreateFrame("CheckButton", nil, scrollChild, "InterfaceOptionsCheckButtonTemplate")
checkBtn:SetPoint("CENTER", -73, -80)
checkBtn.Text:SetText("Save these settings?")
checkBtn:SetScript( "OnClick", function (self, button, down) checkBtnOnClick(); end )
checkBtn:SetChecked(true)

function checkBtnOnClick()
	if (checkBtn:GetChecked()) then
		-- print("You checked the save settings box.")
	else
		-- print("You unchecked the save settings box.")
	end
end



----- INTERFACE OPTIONS X POSITION SLIDER

local xSliderSetTo = xSlider_init

xSlider = CreateFrame("Slider", "xSlider", scrollChild, "OptionsSliderTemplate")
xSlider:SetPoint("TOPLEFT", 40, -175)
xSlider:SetWidth(200)
xSlider:SetHeight(20)
xSlider:SetOrientation('HORIZONTAL')
xSlider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
xSlider:SetMinMaxValues(1,100)
xSlider:SetValueStep(0.01)
xSlider:SetValue(50)
--xSlider:SetValue(xSliderSetTo)
xSlider.tooltipText = 'Adjust x position'
getglobal(xSlider:GetName() .. 'Low'):SetText('Left')
getglobal(xSlider:GetName() .. 'High'):SetText('Right')
getglobal(xSlider:GetName() .. 'Text'):SetText('Position in x\n ')
xSlider:SetScript( "OnValueChanged", function (self, newvalue) xSliderUpdate(gay, newvalue); end )




----- INTERFACE OPTIONS Y POSITION SLIDER

ySlider = CreateFrame("Slider", "ySlider", scrollChild, "OptionsSliderTemplate")
ySlider:SetPoint("TOPRIGHT", -40, -175)
ySlider:SetWidth(200)
ySlider:SetHeight(20)
ySlider:SetOrientation('HORIZONTAL')
ySlider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
ySlider:SetMinMaxValues(1,100)
ySlider:SetValueStep(0.01)
--ySlider:SetValue(ySlider_init)
ySlider:SetValue(50)
ySlider.tooltipText = 'Adjust y position'
getglobal(ySlider:GetName() .. 'Low'):SetText('Bottom')
getglobal(ySlider:GetName() .. 'High'):SetText('Top')
getglobal(ySlider:GetName() .. 'Text'):SetText('Position in y\n ')
ySlider:SetScript( "OnValueChanged", function (self, newvalue) ySliderUpdate(gay, newvalue); end )



----- INTERFACE OPTIONS CHECK BOX 2 (Hide roll messages) AND ON EVENT FUNCTION

local checkBtn2 = CreateFrame("CheckButton", nil, scrollChild, "InterfaceOptionsCheckButtonTemplate")
checkBtn2:SetPoint("CENTER", -65, -265)
checkBtn2.Text:SetText("Hide roll messages")
checkBtn2:SetScript( "OnClick", function (self, button, down) checkBtnOnClick2(); end )
checkBtn2:SetChecked(true)
if ( msgEnable == 1 ) then
	checkBtn2:SetChecked(false)
end


function checkBtnOnClick2()
	if (checkBtn2:GetChecked()) then
		print("Hiding roll messages. (default setting)")
		msgEnable = 0
		DiceDB.msgEnable = 0
	else
		print("Showing roll messages.")
		msgEnable = 1
		DiceDB.msgEnable = 1
	end
end





-- INTERFACE OPTIONS CHECK BOX 3 (Show Dice by Default) AND ON EVENT FUNCTION

local checkBtn3 = CreateFrame("CheckButton", nil, scrollChild, "InterfaceOptionsCheckButtonTemplate")
checkBtn3:SetPoint("CENTER", -70, -310)
checkBtn3.Text:SetText("Show dice by default")
checkBtn3:SetScript( "OnClick", function (self, button, down) checkBtnOnClick3(); end )


function checkBtnOnClick3()
	if (checkBtn3:GetChecked()) then
		print("Showing dice by default. (default setting)")
		showDice = 1
		DiceDB.showDice = 1
	else
		print("Hiding dice by default")
		showDice = 0
		DiceDB.showDice = 0
	end
end


if (showDice == 1) then
	checkBtn3:SetChecked(true)
else
	checkBtn3:SetChecked(false)
end



local miniMapText = scrollChild:CreateFontString("ARTWORK", nil, "GameFontNormal")
miniMapText:SetPoint("TOP", -4, -380)
miniMapText:SetText("-- MINIMAP BUTTON --\n ")

local checkBtn4 = CreateFrame("CheckButton", nil, scrollChild, "InterfaceOptionsCheckButtonTemplate")
checkBtn4:SetPoint("CENTER", -25, -430)
checkBtn4.Text:SetText("Hide")
-- checkBtn4:SetScript( "OnClick", function (self, button, down) checkBtnOnClick4(); end )

local checkBtn5 = CreateFrame("CheckButton", nil, scrollChild, "InterfaceOptionsCheckButtonTemplate")
checkBtn5:SetPoint("CENTER", -47, -500)
checkBtn5.Text:SetText("Save location")

-- local isHiding = 0
-- local function checkBtnOnClick4()
-- 	if (isHiding == 0) then
-- 		MinimapButton:Hide()
-- 		MinimapButton:SetParent(nil)
-- 	else
-- 		isHiding = 1
-- 		MinimapButton:Show()
-- 	end
-- end


-- INTERFACE OPTIONS BUTTON (Reset Default Settings) AND ON EVENT FUNCTION

local function pressBtnOnClick()
	-- print("pressBtn registered a click.")
end

local pressBtn = CreateFrame("Button", nil, scrollChild, "UIPanelButtonTemplate")
pressBtn:SetPoint("CENTER", -5, -570)
pressBtn.Text:SetText("Reset Default Settings")
pressBtn:SetWidth(200)
pressBtn:SetScript( "OnClick", function (self, button, down) pressBtnOnClick(); end )


-- called when interface options panel "Canel" button is pressed
-- function Dice.panel.cancel()
-- 	xpcall(function()
-- 		print("Cancel button pressed.");
-- 		print(xSlider_init);
-- 	end, geterrorhandler())
-- end





---------------------------------------------
















---------- DICE ROLL FRAME AND INTERACTION FUNCTIONS ----------


local rollFrame = CreateFrame("Button", "RollButton", UIParent)
rollFrame:SetFrameStrata("BACKGROUND")
rollFrame:SetWidth(64)
rollFrame:SetHeight(64)

local rollTexture = rollFrame:CreateTexture(nil, "BACKGROUND")
rollTexture:SetTexture("Interface\\Addons\\Dice\\die.tga")
rollTexture:SetAllPoints(rollFrame)
rollFrame.texture = rollTexture

local x = 0
local y = 0
local xRESTORE = x
local yRESTORE = y
rollFrame:SetPoint("CENTER", correspondingX, correspondingY)
rollFrame:Show()
rollFrame:Hide()
rollFrame:SetParent(nil)

if (showDice == 1) then
	rollFrame:SetPoint("CENTER", correspondingX, correspondingY);
	rollFrame:Show()
end




-- @ CURSOR DROP DOWN MENU FOR MOVING POSITION OF DICE

local menu = {
	{ text = "Select an Option", isTitle = true },
	{ text = "Move Up", hasArrow = true,
		menuList = {
			{ text = "Move up 25px", func = function() y = (y + 25); print("Moved up 25px."); rollFrame:SetPoint("CENTER", x, y); end },
			{ text = "Move up 50px", func = function() y = (y + 50); print("Moved up 50px."); rollFrame:SetPoint("CENTER", x, y); end },
			{ text = "Move up 100px", func = function() y = (y + 100); print("Moved up 100px."); rollFrame:SetPoint("CENTER", x, y); end }
		}
	},
	{ text = "Move Down", hasArrow = true,
		menuList = {
			{ text = "Move down 25px", func = function() y = (y - 25); print("Moved down 25px."); rollFrame:SetPoint("CENTER", x, y); end },
			{ text = "Move down 50px", func = function() y = (y - 50); print("Moved down 50px."); rollFrame:SetPoint("CENTER", x, y); end },
			{ text = "Move down 100px", func = function() y = (y - 100); print("Moved down 100px."); rollFrame:SetPoint("CENTER", x, y); end }
		}
	},
	{ text = "Move Left", hasArrow = true,
		menuList = {
			{ text = "Move left 25px", func = function() x = (x - 25); print("Moved left 25px."); rollFrame:SetPoint("CENTER", x, y); end },
			{ text = "Move left 50px", func = function() x = (x - 50); print("Moved left 50px."); rollFrame:SetPoint("CENTER", x, y); end },
			{ text = "Move left 100px", func = function() x = (x - 100); print("Moved left 100px."); rollFrame:SetPoint("CENTER", x, y); end }
		}
	},
	{ text = "Move Right", hasArrow = true,
		menuList = {
			{ text = "Move right 25px", func = function() x = (x + 25); print("Moved right 25px."); rollFrame:SetPoint("CENTER", x, y); end },
			{ text = "Move right 50px", func = function() x = (x + 50); print("Moved right 50px."); rollFrame:SetPoint("CENTER", x, y); end },
			{ text = "Move right 100px", func = function() x = (x + 100); print("Moved right 100px."); rollFrame:SetPoint("CENTER", x, y); end }
		}
	},
	{ text = "Center of screen (default)", hasArrow = true,
		menuList = {
			{ text = "Center of screen (default)", func = function() x = 0; y = 0; print("Moved to center of screen."); rollFrame:SetPoint("CENTER", x, y); end }
		}
	},
	{ text = "Top left of screen", hasArrow = true,
		menuList = {
			{ text = "Top left of screen", func = function() x = (GetScreenWidth()/-2 + 118.5185546875); y = (GetScreenHeight()/2 - 86.66668701172); print("Moved to top left of screen."); rollFrame:SetPoint("CENTER", x, y); end }
		}
	},
	{ text = "Top right of screen", hasArrow = true,
		menuList = {
			{ text = "Top right of screen", func = function() x = (GetScreenWidth()/2 - 118.5185546875); y = (GetScreenHeight()/2 - 86.66668701172); print("Moved to top right of screen."); rollFrame:SetPoint("CENTER", x, y); end }
		}
	},
	{ text = "Bottom left of screen", hasArrow = true,
		menuList = {
			{ text = "Bottom left of screen", func = function() x = (GetScreenWidth()/-2 + 118.5185546875); y = (GetScreenHeight()/-2 + 86.66668701172); print("Moved to bottom left of screen (default location)."); rollFrame:SetPoint("CENTER", x, y); end }
		}
	},
	{ text = "Bottom right of screen", hasArrow = true,
		menuList = {
			{ text = "Bottom right of screen", func = function() x = (GetScreenWidth()/2 - 118.5185546875); y = (GetScreenHeight()/-2 + 86.66668701172); print("Moved to bottom right of screen."); rollFrame:SetPoint("CENTER", x, y); end }
		}
	},
	{ text = "Reset", func = function()  x = xRESTORE; y = yRESTORE; print("Reset position."); rollFrame:SetPoint("CENTER", x, y); end }
}

local menuFrame = CreateFrame("Frame", "TestMenuFrame", UIParent, "UIDropDownMenuTemplate")



local resetTaunts = 0

local taunts = {"Rollin with my gnomies.", "Am I rigging your rolls?", "You'll never know.", "Quit clicking me.", "That's enough.", "Stop it!"};
rollFrame:RegisterForClicks("AnyUp");

rollFrame:SetScript("OnClick", function (self, button, down)
	self:SetID((self:GetID() or 1) + 1);

	if (self:GetID() == 7) then
		self:SetID(1);
	end
	if (resetTaunts == 1) then
		self:SetID(1);
		resetTaunts = 0;
	end

	-- flash the dice frame when clicked
	UIFrameFlash(rollFrame, 0.25, 0.25, 0.25, true, 0, 0);

	if (taunts[self:GetID()]) then
		if (msgEnable == 1) then
			print(taunts[self:GetID()]);
		end
		local roll = RandomRoll(1, 100);
		SendChatMessage(roll);
	else
		self.Hide();
	end

end);




local function diceDisplayHandler(arg1)
	local userArgument = string.len(arg1) > 0

	if (userArgument) then
		if (arg1 == "hide") then
			rollFrame:Hide();
			rollFrame:SetParent(nil);
		elseif (arg1 == "show") then
			rollFrame:SetPoint("CENTER", correspondingX, correspondingY);
			rollFrame:Show();
		elseif (arg1 == "hidemessages") then
			msgEnable = 0;
			print("Messages have been disabled.")
		elseif (arg1 == "showmessages") then
			msgEnable = 1;
			resetTaunts = 1;
			print("Messages have been enabled.")
		elseif (arg1 == "move") then
			EasyMenu(menu, menuFrame, "cursor", 0 , 0, "MENU");
			menuFrame:Show();
		elseif (arg1 == "config") then
			InterfaceOptionsFrame_OpenToCategory(Dice.panel);
			InterfaceOptionsFrame_OpenToCategory(Dice.panel);
		else
			message("Invalid command!")
		end
	else
		print("\n")
		print("----------------------------------\n\n")
		print("Valid commands:\n\n" .. "  /dice config  ~  opens the interface config menu\n  /dice show  ~  shows the dice\n  /dice hide  ~  hides the dice\n  /dice move  ~  open movement menu\n  /dice showmessages  ~  enables messages\n  /dice hidemessages  ~  disables messages\n\n")
		print("----------------------------------\n")
	end
end


---------------------------------------------------------------


local xCenter = 0
local yCenter = 0




function xSliderUpdate(_, newvalue)
	xSliderPercent = (newvalue - newvalue%1) / 1;

	if (xSliderPercent == 50) then
		correspondingX = 0
		rollFrame:SetPoint("CENTER", correspondingX, correspondingY);

	elseif (newvalue == 1) then
		correspondingX = absoluteXmin
		rollFrame:SetPoint("CENTER", correspondingX, correspondingY);

	elseif (newvalue == 100) then
		correspondingX = absoluteXmax
		rollFrame:SetPoint("CENTER", correspondingX, correspondingY);

	elseif (newvalue < 50) then
		correspondingX = ( absoluteXmin / 50.0  * newvalue - absoluteXmin ) * -1
		rollFrame:SetPoint("CENTER", correspondingX, correspondingY);

	elseif (newvalue > 50) then
		correspondingX = absoluteXmax / 50.0  * newvalue - absoluteXmax
		rollFrame:SetPoint("CENTER", correspondingX, correspondingY);
	end
end

function ySliderUpdate(_, newvalue)
	ySliderPercent = (newvalue - newvalue%1) / 1;

	if (ySliderPercent == 50) then
		correspondingY = 0
		rollFrame:SetPoint("CENTER", correspondingX, correspondingY);

	elseif (newvalue == 1) then
		correspondingY = absoluteYmin
		rollFrame:SetPoint("CENTER", correspondingX, correspondingY);

	elseif (newvalue == 100) then
		correspondingY = absoluteYmax
		rollFrame:SetPoint("CENTER", correspondingX, correspondingY);

	elseif (newvalue < 50) then
		correspondingY = ( absoluteYmin / 50.0  * newvalue - absoluteYmin ) * -1
		rollFrame:SetPoint("CENTER", correspondingX, correspondingY);

	elseif (newvalue > 50) then
		correspondingY = absoluteYmax / 50.0  * newvalue - absoluteYmax
		rollFrame:SetPoint("CENTER", correspondingX, correspondingY);

	end
end


-- save current slider positions in DiceDB (correspondingX and correspondingY)
function Dice.panel.okay()
	xpcall(function()
		saveDicePosition();
		saveSliderPosition();
		checkBtn2_update();
		checkBtn3_update();
	end, geterrorhandler())
end

function checkBtn2_update()
	if ( msgEnable == 1 ) then
		checkBtn2:SetChecked(false)
	end
end

function checkBtn3_update()
	if ( checkBtn3:GetChecked() ) then
		checkBtn3:SetChecked(true)
	else
		checkBtn3:SetChecked(false)
	end
end


-- save current slider positions in DiceDB if save settings button is checked
function saveDicePosition()
	if ( checkBtn:GetChecked() ) then
		DiceDB.xDefault = correspondingX;
		DiceDB.yDefault = correspondingY;
		print("Saving dice x position: " .. correspondingX)
		print("Saving dice y position: " .. correspondingY)
	end
end


-- called when interface options panel is opened
function Dice.panel.refresh()
	xpcall(function()
		setSliderPosition();
		checkBtn2_update();
	end, geterrorhandler())
end


-- 
function saveSliderPosition()
	if ( checkBtn:GetChecked() ) then
		DiceDB.xSliderDefault = xSlider:GetValue();
		DiceDB.ySliderDefault = ySlider:GetValue();
		xSlider_pos = xSlider:GetValue();
		ySlider_pos = ySlider:GetValue();
	end
end

function loadSliderPosition(x, y)
	xSlider:SetValue(x)
	ySlider:SetValue(y)
end


--
function setSliderPosition()
	if ( checkBtn:GetChecked() ) then
		xSlider:SetValue(xSlider_pos);
		ySlider:SetValue(ySlider_pos);
	else
		xSlider:SetValue(xSlider_init);
		ySlider:SetValue(ySlider_init);
	end
end





---------- MINIMAP ICON ----------


local MinimapButton = CreateFrame('Button', nil, Minimap)


function MinimapButton:Load()
	self:SetFrameStrata('HIGH')
	self:SetWidth(31)
	self:SetHeight(31)
	self:SetFrameLevel(8)
	self:RegisterForClicks('anyUp')
	self:SetHighlightTexture('Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight')

	local overlay = self:CreateTexture(nil, 'OVERLAY')
	overlay:SetWidth(53)
	overlay:SetHeight(53)
	overlay:SetTexture('Interface\\Minimap\\MiniMap-TrackingBorder')
	overlay:SetPoint('TOPLEFT')

	local icon = self:CreateTexture(nil, 'BACKGROUND')
	icon:SetWidth(20)
	icon:SetHeight(20)
	icon:SetTexture("Interface\\Addons\\Dice\\die.tga")
	icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
	icon:SetPoint('TOPLEFT', 7, -5)
	self.icon = icon


	self:SetScript('OnClick', self.OnClick)

	self:SetScript("OnMouseDown", self.OnMouseDown)

	self:RegisterForDrag("LeftButton")
	self:SetScript("OnDragStart", self.OnDragStart)
	self:SetScript("OnDragStop", self.OnDragStop)

	-- self:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", -2, 2)
	self:SetPoint("TOPLEFT", Minimap, "TOPLEFT", xGoTo_miniMap, yGoTo_miniMap)

end


function MinimapButton:OnClick(button)
	if button == 'LeftButton' then
		if (isShowing == 0) then
			rollFrame:SetPoint("CENTER", correspondingX, correspondingY);
			rollFrame:Show();
			isShowing = 1
			DiceDB.isShowing = 1
		else
			rollFrame:Hide()
			rollFrame:SetParent(nil)
			isShowing = 0
			DiceDB.isShowing = 0
		end
	elseif button == 'RightButton' then
		InterfaceOptionsFrame_OpenToCategory(Dice.panel);
		InterfaceOptionsFrame_OpenToCategory(Dice.panel);
	end
end


-- function MinimapButton:OnEnter()
-- 	GameTooltip_SetDefaultAnchor(GameTooltip,Minimap)
-- 	GameTooltip:SetAnchorType("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", -2, 2)
-- 	GameTooltip:AddLine('Hello')
-- 	GameTooltip:AddLine('Hello2')
-- 	GameTooltip:Show()
-- end
-- function MinimapButton:OnLeave()
-- 	GameTooltip:Hide()
-- end

function updateDB(x, y)
	theta = math.deg(math.atan2(y,x))
	DiceDB.minimapPosition = theta
end


function MinimapButton:Move()
	local angle = DiceDB.minimapPosition or 0
	local xpos = 80*cos(angle)
	local ypos = 80*sin(angle)
	MinimapButton:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 52 - xpos, ypos - 52)
	updateDB(xpos, ypos)
end


function MinimapButton:OnUpdate()
	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()
	xpos = xmin - xpos / Minimap:GetEffectiveScale() + 70
	ypos = ypos / Minimap:GetEffectiveScale() - ymin - 70

	DiceDB.minimapPosition = math.deg(math.atan2(ypos,xpos))
	MinimapButton:Move()
end


function MinimapButton:OnDragStart()
	self:SetScript("OnUpdate", MinimapButton.OnUpdate)
end

function MinimapButton:OnDragStop()
	self:SetScript("OnUpdate", nil)
end


function moveMinimapButton(angle)
	local xpos = 80*cos(angle)
	local ypos = 80*sin(angle)
	MinimapButton:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 52 - xpos, ypos - 52)
end


MinimapButton:Load()


----------------------------------


function redrawDice(x, y)
	rollFrame:SetPoint("CENTER", correspondingX, correspondingY)
	rollFrame:Show()
end

function showDiceDefault()
	checkBtn3:SetChecked(true)
end



---------- FACTIONS FRAME AND SLASH COMMAND FUNCTIONS ----------


-- local newFrame = CreateFrame("Button", nil, UIParent)
-- newFrame:SetFrameStrata("BACKGROUND")
-- newFrame:SetWidth(128)
-- newFrame:SetHeight(64)

-- local newTexture = newFrame:CreateTexture(nil, "BACKGROUND")
-- newTexture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Factions.blp")
-- newTexture:SetAllPoints(newFrame)
-- newFrame.texture = newTexture

-- newFrame:SetPoint("CENTER", 0, 350)
-- newFrame:Show()
-- newFrame:Hide()
-- newFrame:SetParent(nil)


-- local function showFactions()
-- 	newFrame:SetPoint("CENTER", 0, 350)
-- 	newFrame:Show()
-- end

-- local function hideFactions()
-- 	if (MouseIsOver(newFrame)) then
-- 		message("Mouse is over the frame! Move mouse to hide.")
-- 	else
-- 		newFrame:Hide()
-- 		newFrame:SetParent(nil)
-- 	end
-- end


-- local function showFactionsHandler(argument)
-- 	local userAddedArgument = string.len(argument) > 0

-- 	if (userAddedArgument) then
-- 		if (argument == "show") then
-- 			showFactions()
-- 		elseif (argument == "hide") then
-- 			hideFactions()
-- 		elseif (argument == "armor") then
-- 			print(GetAverageItemLevel("Ngmi"))
-- 		else
-- 			message("Invalid command!")
-- 		end
-- 	else
-- 		print("\n")
-- 		print("----------------------------------\n\n")
-- 		print("Valid commands:\n\n" .. "  /factions show  ~  shows the faction icons\n  /factions hide  ~  hides the faction icons\n\n")
-- 		print("----------------------------------\n")
-- 	end
-- end


----------------------------------------------------------------







---------- PRINTING TIME IN-GAME ----------


-- local function printTime()
-- 	local currentTime = GetTime();
-- 	print("Raw value: " .. currentTime);

-- 	currentTimeTruncated = (GetTime() - GetTime()%1) / 1;
-- 	print("Truncated value: " .. currentTimeTruncated);

-- 	currentTimeExtended = currentTime*1000;
-- 	currentTimePrecise = (currentTimeExtended - currentTimeExtended%1) / 1;
-- 	print("Precise value: " .. currentTimePrecise);
-- end


-------------------------------------------




local function reloader()
	ReloadUI();
end









SlashCmdList["DICE"] = diceDisplayHandler
SlashCmdList["FACTIONS"] = showFactionsHandler
SlashCmdList["PRINTTIME"] = printTime
SlashCmdList["RE"] = reloader